#include "cb.h"
#include <stdio.h>
#include <unistd.h>
#include <limits.h>

int usage(void)
{
    printf("Usage: cb [-hio] [-s 'write to clipboard']\n"
           "  -h  show this message\n"
           "  -i  write to clipboard from STDIN\n"
           "  -o  read from clipboard\n"
           "  -s  write to clipboard from argument\n");
    return -1;
}

int version(void)
{
    printf("cb version %s (build: %s)\n"
           "Copyright(C) 2004 Hiroyuki OYAMA. Japan\n",
           CB_VERSION, CB_BUILD_NUMBER);
    return -1;
}

int main(int argc, char *argv[])
{
    int ch, in, out, string;
    char *src;

    while ((ch = getopt(argc, argv, "hvios:")) != -1) {
        switch (ch) {
        case 'h':
            return usage();
        case 'v':
            return version();
        case 'i':
            in = 1;
            break;
        case 'o':
            out = 1;
            break;
        case 's':
            in = 1;
            string = 1;
            src = optarg;
            break;
        default:
            break;
        }
    }
    argc -= optind;
    argv += optind;
    if (argc < 0) {
        out = 1;
    }


    if (out) {       /* read pasteboard */
        cb_cat_string();
    }
    else if (in) {   /* write pasteboard */
        char buff[NL_MSGMAX];
        size_t l;

        if (!string) {
            l = fread(buff, sizeof(buff), sizeof(char), stdin);
            src = buff;
        }
        cb_set_string(src);
    }
    else {
        cb_cat_string();
    }

    return 0;
}
